package com.izouma.awesomeadmin.web;

import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.PowerInfo;
import com.izouma.awesomeadmin.service.PowerInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * power_info controller类
 * Wed Apr 11 11:04:02 CST 2018  Suo Chen Cheng
 */
@Controller
@RequestMapping("/powerInfo")
public class PowerInfoController {

    @Autowired
    private PowerInfoService powerInfoService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(PowerInfo record) {

        List<PowerInfo> pp = powerInfoService.getPowerInfoList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getPowerInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getPowerInfo(@RequestParam(required = false, value = "id") String id) {

        PowerInfo data = powerInfoService.getPowerInfoById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(PowerInfo record) {

        PowerInfo data = powerInfoService.getPowerInfo(record);
        return new Result(true, data);
    }

    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, PowerInfo record) {

        Map<String, Object> result = new HashMap<>();

        List<PowerInfo> pp = powerInfoService.getPowerInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }

    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(PowerInfo record, String menuInfo) {
        boolean num = false;
        String menus[] = menuInfo.split(",");

        if (menus[0] != "") {
            for (int i = 0; i < menus.length; i++) {
                PowerInfo powerInfo = new PowerInfo();
                powerInfo.setMenuId(Integer.parseInt(menus[i]));
                powerInfo.setRoleId(record.getRoleId());

                num = powerInfoService.createPowerInfo(powerInfo);
            }
        }
/*
		boolean num = powerInfoService.createPowerInfo(record);*/

        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updatePowerInfo(PowerInfo record) {

        boolean num = powerInfoService.updatePowerInfo(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }


    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/updateByRoleId", method = RequestMethod.POST)
    @ResponseBody
    public Result updateByRoleId(PowerInfo record, String menuInfo) {
        boolean num = false;
        boolean n = powerInfoService.deletePowerInfoByRoleId(record.getRoleId() + "");

        String menus[] = menuInfo.split(",");
        if (menus[0] != "") {
            //String powerStr = "#";
            //powerStr+= menuInfo.replace(',','#')+"#";
            for (int i = 0; i < menus.length; i++) {
                PowerInfo powerInfo = new PowerInfo();
                powerInfo.setMenuId(Integer.parseInt(menus[i]));
                powerInfo.setRoleId(record.getRoleId());

                num = powerInfoService.createPowerInfo(powerInfo);
            }
            //request.getSession().setAttribute("powerStr", powerStr);
        }
        if (n) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deletePowerInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = powerInfoService.deletePowerInfo(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    @RequestMapping(value = "/getPowerTree", method = RequestMethod.GET)
    @ResponseBody
    public Result getPowerTree(Page page, PowerInfo record) {

        Map<String, Object> result = new HashMap<>();
        page.setPageNumber(200);
        List<PowerInfo> pp = powerInfoService.getPowerInfoByPage(page, record);

        if (pp != null && pp.size() != 0) {

            String[] res = new String[pp.size()];
            for (int i = 0; i < res.length; i++) {
                res[i] = pp.get(i).getMenuId() + "";
            }

            result.put(AppConstant.PAGE, page);
            result.put("pp", res);
            return new Result(true, result);
        }
        return new Result(false, "");
    }


}

